import Vue from 'vue'

import Cookies from 'js-cookie'

import Element from 'element-ui'
import "ant-design-vue/dist/antd.less";
import Antd from "ant-design-vue";
import './assets/styles/element-variables.scss'
import '../public/static/css/app~d0ae3f07.292700d9.css'
import '../public/static/css/chunk-vendors~7529033b.79edd185.css'

import '@/assets/styles/index.scss' // global css
import '@/assets/styles/ruoyi.scss' // ruoyi css
import App from './App'
import store from './store'
import router from './router'
import directive from './directive' // directive
import plugins from './plugins' // plugins
import { download } from '@/utils/request'

import './assets/icons' // icon
import './permission' // permission control
import { getDicts } from "@/api/system/dict/data";
import { getConfigKey } from "@/api/system/config";
import { parseTime, resetForm, addDateRange, selectDictLabel, selectDictLabels, handleTree } from "@/utils/ruoyi";
// 分页组件
import Pagination from "@/components/Pagination";
// 自定义表格工具组件
import RightToolbar from "@/components/RightToolbar"
// 富文本组件
import Editor from "@/components/Editor"
// 文件上传组件
import FileUpload from "@/components/FileUpload"
// 图片上传组件
import ImageUpload from "@/components/ImageUpload"
// 图片预览组件
import ImagePreview from "@/components/ImagePreview"
// 字典标签组件
import DictTag from '@/components/DictTag'
// 头部标签组件
import VueMeta from 'vue-meta'
// 字典数据组件
import DictData from '@/components/DictData'

// knowledge 知识图谱新增 start 以后可以整合到plugin里
import eventBus from "./plugins/knowledge/eventBus";
import modalManager from "./plugins/knowledge/modalManager";
import formValidateFields from "./plugins/knowledge/formValidateFields";
import modalList from "@/views/knowledge/modal/index";
import contentmenu from "v-contextmenu";
import "v-contextmenu/dist/index.css";
import '@/assets/knowledge/config/config'
import moment from "moment";
Vue.prototype.$const = window.global.const;
// knowledge 知识图谱新增 end

// 全局方法挂载
Vue.prototype.getDicts = getDicts
Vue.prototype.getConfigKey = getConfigKey
Vue.prototype.parseTime = parseTime
Vue.prototype.resetForm = resetForm
Vue.prototype.addDateRange = addDateRange
Vue.prototype.selectDictLabel = selectDictLabel
Vue.prototype.selectDictLabels = selectDictLabels
Vue.prototype.download = download
Vue.prototype.handleTree = handleTree

// 全局组件挂载
Vue.component('DictTag', DictTag)
Vue.component('Pagination', Pagination)
Vue.component('RightToolbar', RightToolbar)
Vue.component('Editor', Editor)
Vue.component('FileUpload', FileUpload)
Vue.component('ImageUpload', ImageUpload)
Vue.component('ImagePreview', ImagePreview)

Vue.use(directive)
Vue.use(plugins)
Vue.use(contentmenu);
Vue.use(eventBus);
Vue.use(modalManager, {
  modals: modalList
});
Vue.use(formValidateFields);
Vue.use(VueMeta)
DictData.install()

/**
 * If you don't want to use mock-server
 * you want to use MockJs for mock api
 * you can execute: mockXHR()
 *
 * Currently MockJs will be used in the production environment,
 * please remove it before going online! ! !
 */

Vue.use(Element, {
  size: Cookies.get('size') || 'medium' // set element-ui default size
})
Vue.use(Antd);

Vue.config.productionTip = false

// knowledge add start
Vue.prototype.$moment = moment;
Vue.prototype.$checkSpecialChar = function (value) {
  const pattern = /[`~!@#$^&*()=|{}':;',[\].<>《》/?~！@#￥……&*（）——|{}【】‘；：”“'。，、？ ]/g
  const matchList = value.match(pattern)
  const uniqueMatchList = []
  if (matchList) {
    matchList.map(v => {
      uniqueMatchList.indexOf(v) === -1 ? uniqueMatchList.push(v) : null
    })
  }
  return uniqueMatchList
}
const menuList = window.global.const.menuList
Vue.prototype.menus = menuList

//超过10个字符显示省略号
Vue.filter("ellipsis", function (value, num) {
  if (typeof num === "undefined") num = 10;
  if (!value) return "";
  value = value.toString();
  if (value.length > num) {
    return value.substr(0, num) + "...";
  } else {
    return value;
  }
});
// knowledge add end


new Vue({
  el: '#app',
  router,
  store,
  render: h => h(App)
})
